// Extra little details script

local overwritemusic = CV_FindVar("pikamusic")
local usevox = CV_FindVar("pikavoices")



// Music replacement
local chuMusic = function(p,oldname,newname,flags,loop,pos,fadeout,fadein)
	if not overwritemusic.value
		return nil end
		
	// All songs from Pokémon Black & White or Pokémon Black 2 & White 2
	
	if newname:lower() == "_clear" // Act Clear -> Victory against Wild Pokémon
		if mapheaderinfo[gamemap].bonustype >= 1
			return "pkbwin", flags, true, pos, fadeout, fadein
		else
			return "pkvict", flags, true, pos, fadeout, fadein
		end
	elseif newname:lower() == "_drown" // Drowning -> A Tight Spot During Battle! (arr. PikaJade)
		return "pkdrwn"
	elseif newname:lower() == "_1up" // 1-Up -> Obtained a Key Item!
		return "pklife"
	elseif newname:lower() == "_gover" // Game Over -> Mission Failed!
		return "pkover"
	elseif newname:lower() == "_conti" // Continue -> Game Sync
		return "pkcont", flags, true, pos, fadeout, fadein
	elseif newname:lower() == "chfail" // Special Stage Fail -> Move Deleted
		return "pkspcl", flags, false, pos, fadeout, fadein
	elseif newname:lower() == "chpass" // Special Stage Pass -> Congratulations! Your Pokémon Evolved!
		return "pkspcw", flags, false, pos, fadeout, fadein
	end
	
	if overwritemusic.value != 2
		return nil end
	
	if newname:lower() == "vsboss" // VS Dr. Eggman -> Battle! (Gym Leader)
		if oldname:lower() == "pkboss"
			return true
		end
		return "pkboss"
	elseif newname:lower() == "cezr" // The Bridge Is Collapsing! -> A Tight Spot During Battle! 
		if oldname:lower() == "pkbrdg"
			return true
		end
		return "pkbrdg"
	elseif newname:lower() == "vsfang" // VS Fang the Sniper -> Battle! (Gym Leader - Kanto)
		if oldname:lower() == "vpkfang"
			return true
		end
		return "pkfang"
	elseif newname:lower() == "vsmetl" // VS Metal Sonic -> Battle! (Elite Four)
		if oldname:lower() == "pkmetl"
			return true
		end
		return "pkmetl"
	elseif newname:lower() == "bcz2" // Black Core Zone Act 2 – Anticipation -> Dragonspiral Tower Top Floor
		if oldname:lower() == "pkbcz2"
			return true
		end
		return "pkbcz2"
	elseif newname:lower() == "vsbrak" // VS Black Eggman -> Battle! (Champion - Johto)
		if oldname:lower() == "pkbrak"
			return true
		end
		return "pkbrak"
	elseif newname:lower() == "_shoes" // Super Sneakers -> Trainers' Eyes Meet (Cyclist)
		return "pkshoe", flags, true, pos, fadeout, fadein
	elseif newname:lower() == "_inv" // Invincible -> Trainers' Eyes Meet (Ace Trainer)
		return "pkinvn", flags, true, pos, fadeout, fadein
	end
end

// Switch music to Pikachu music
addHook("MusicChange", function(oldname, newname, flags, loop, pos, fadeout, fadein)
	
	// If the local player is Pikachu
	if displayplayer
	and displayplayer.chuTable
		return chuMusic(displayplayer, oldname, newname, flags, loop, pos, fadeout, fadein)
		
	// If Player 2 (splitscreen) is Pikachu
	elseif secondarydisplayplayer
	and secondarydisplayplayer.chuTable
		return chuMusic(secondarydisplayplayer, oldname, newname, flags, loop, pos, fadeout, fadein)
	end
	
end)

// Switch music after a boss, since SRB2 doesn't do that with changed music by default
addHook("BossDeath",function(mo)

	if not (S_MusicPlaying(displayplayer)
	and mapheaderinfo[gamemap].muspostbossname
	and mapheaderinfo[gamemap].muspostbossname != "")
		return end
	
	local mus = S_MusicName(displayplayer)
	if mus == "pkboss"
	or mus == "pkfang"
	or mus == "pkmetl"
	or mus == "pkbrak"
		local map = mapheaderinfo[gamemap]
		S_ChangeMusic(map.muspostbossname, true, displayplayer, 0, map.muspostbosspos, MUSICRATE*3/2, map.muspostbossfadein);
	end
end)

// Reload music after loading in, since otherwise going to a boss level from the level select wouldn't play the correct music
addHook("MapLoad",function()
	if S_MusicPlaying(displayplayer)
		S_ChangeMusic(S_MusicName(displayplayer))
	end
end)

// Some extra player details
addHook("PlayerThink",function(p)
	local mo = p.mo
	
	if mo and mo.valid
	and mo.player and mo.player.chuTable
		// Don't let Pikachu's 1up jingle run too long
		if overwritemusic.value
			p.powers[pw_extralife] = min($,TICRATE*7/3)
		end
		
		// Victory pose
		if (p.exiting or (p.pflags & PF_FINISHED))
		and mapheaderinfo[gamemap].bonustype != -1
			
			// Voice line
			if not p.chuTable.victoryTaunted
				p.chuTable.victoryTaunted = true
				if usevox.value
					if P_RandomChance(FU/2)
						S_StartSound(mo,sfx_pvyay1)
					else
						S_StartSound(mo,sfx_pvyay2)
					end
				end
			end
			
			// Animation
			if P_IsObjectOnGround(mo)
			and mo.state != S_PLAY_CHUVICTORY
			and mo.state != S_PLAY_CHUVICTORY_FINISH
				mo.state = S_PLAY_CHUVICTORY
			end
		end
		
		// Dead 'chus collide with the floor, and enter a new state when they do
		if p.playerstate == PST_DEAD
		and (p.deadtimer > 1
		or mo.spriteyscale == FU/2)
			
			if mo.flags & MF_NOCLIPHEIGHT
				mo.flags = $&~ MF_NOCLIPHEIGHT
				mo.momz = $/2
			end
			
			p.camerascale = FixedDiv(skins[p.skin].camerascale,mo.scale)
			
			if P_IsObjectOnGround(mo)
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
				
				if mo.scale == FU/10
					mo.alpha = 0
				elseif mo.state != S_PLAY_DEADCHU
				and mo.state != S_PLAY_DEADCHU_FINISH
					mo.state = S_PLAY_DEADCHU
					S_StartSound(mo,sfx_pkfain)
					mo.destscale = FU/10 // Shrink out
				end
			end
		end
	end
end,MT_PLAYER)

// Death voicelines
addHook("MobjDeath",function(t,i,s,dt)
	if t and t.valid 
	and t.player and t.player.chuTable
		if dt == DMG_CRUSHED
			t.spriteyscale = FU/2
		end
		
		if usevox.value
			S_StopSoundByID(mo,sfx_pvow1)
			S_StopSoundByID(mo,sfx_pvow2)
			
			if dt == DMG_DROWNED or dt == DMG_SPACEDROWN
				return
			elseif dt == DMG_CRUSHED
				S_StartSound(mo,sfx_pvow2)
			elseif dt == DMG_DEATHPIT
				S_StartSound(mo,sfx_pvfall)
			elseif P_RandomChance(FU/2)
				S_StartSound(mo,sfx_pvdie1)
			else
				S_StartSound(mo,sfx_pvdie2)
			end
		end
	end
end,MT_PLAYER)

// Pain voicelines
addHook("MobjDamage",function(t,i,s,d,dt)
	if usevox.value
	and t and t.valid 
	and t.player and t.player.chuTable
	and not (dt & DMG_INSTAKILL)
	and (t.player.rings > 0 or t.player.powers[pw_shield])
		if P_RandomChance(FU/2)
			S_StartSound(mo,sfx_pvow1)
		else
			S_StartSound(mo,sfx_pvow2)
		end
	end
end,MT_PLAYER)

// Startup sound
local playedStartupSound = false
addHook("ThinkFrame",function()
	if not playedStartupSound
		playedStartupSound = true
		S_StartSound(nil,sfx_pvname)
	end
end)